package com.zhongzheng.modules.grade.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.grade.bo.ClassGradeGoodsAddBo;
import com.zhongzheng.modules.grade.bo.ClassGradeGoodsQueryBo;
import com.zhongzheng.modules.grade.bo.ClassGradeGoodsEditBo;
import com.zhongzheng.modules.grade.domain.ClassGradeGoods;
import com.zhongzheng.modules.grade.mapper.ClassGradeGoodsMapper;
import com.zhongzheng.modules.grade.vo.ClassGradeGoodsVo;
import com.zhongzheng.modules.grade.service.IClassGradeGoodsService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 班级关联商品Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-10
 */
@Service
public class ClassGradeGoodsServiceImpl extends ServiceImpl<ClassGradeGoodsMapper, ClassGradeGoods> implements IClassGradeGoodsService {

    @Override
    public ClassGradeGoodsVo queryById(Long gradeId){
        ClassGradeGoods db = this.baseMapper.selectById(gradeId);
        return BeanUtil.toBean(db, ClassGradeGoodsVo.class);
    }

    @Override
    public List<ClassGradeGoodsVo> queryList(ClassGradeGoodsQueryBo bo) {
        LambdaQueryWrapper<ClassGradeGoods> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getGradeId() != null, ClassGradeGoods::getGradeId, bo.getGradeId());
        lqw.eq(bo.getGoodsId() != null, ClassGradeGoods::getGoodsId, bo.getGoodsId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ClassGradeGoodsVo> entity2Vo(Collection<ClassGradeGoods> collection) {
        List<ClassGradeGoodsVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ClassGradeGoodsVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ClassGradeGoods> page = (Page<ClassGradeGoods>)collection;
            Page<ClassGradeGoodsVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ClassGradeGoodsAddBo bo) {
        ClassGradeGoods add = BeanUtil.toBean(bo, ClassGradeGoods.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ClassGradeGoodsEditBo bo) {
        ClassGradeGoods update = BeanUtil.toBean(bo, ClassGradeGoods.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ClassGradeGoods entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
